var Markee =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = __webpack_require__(1);
exports.default = index_1.Markee;
//# sourceMappingURL=index.js.map

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var defaultConfig = {
    initialText: 'I am a sample text, you can highlight me!',
    startIdx: 0,
    endIdx: 1,
    markerClass: 'marker',
    tokenClass: 'token',
    beginClass: 'begin',
    endClass: 'end',
    selectedClass: 'selected',
    draggedClass: 'dragged'
};
var Markee = /** @class */ (function () {
    function Markee(el, config) {
        this.el = el;
        this.config = config;
        this.config = Object.assign({}, defaultConfig, this.config);
        this.createTokens();
        this.initContainer();
        this.initDragEvents();
        this.initClickEvents();
    }
    Markee.prototype.initContainer = function () {
        this.el.style.display = 'flex';
        this.el.style.userSelect = 'none';
        this.begin = this.createMarker(true, this.config.startIdx * 2);
        this.end = this.createMarker(false, this.config.endIdx * 2);
        this.el.appendChild(this.begin.node);
        this.el.appendChild(this.end.node);
    };
    Markee.prototype.createTokens = function () {
        var _this = this;
        this.el.innerHTML = this.config.initialText
            .split(' ')
            .map(function (t, idx) {
            var order = idx * 2 + 1;
            var selectedClass = (idx >= _this.config.startIdx && idx < _this.config.endIdx)
                ? _this.config.selectedClass : '';
            return "<div class=\"" + _this.config.tokenClass + " " + selectedClass + "\" data-order=" + order + " style=\"order:" + order + "\">" +
                (t + "</div>");
        })
            .join('');
    };
    Markee.prototype.initDragEvents = function () {
        var _this = this;
        this.el.addEventListener('dragstart', function (e) {
            var target = e.target;
            if (target.classList.contains(_this.config.markerClass)) {
                _this.dragged = (target.id === _this.config.beginClass) ? _this.begin : _this.end;
                // Just to keep Firefox happy.
                e.dataTransfer.setData('Text', 'random');
                setTimeout(function () { return target.classList.add(_this.config.draggedClass); });
            }
        });
        this.el.addEventListener('dragenter', function (e) {
            var target = e.target;
            if (_this.dragged && _this.isToken(target)) {
                var order = Number.parseInt(target.dataset.order);
                if (_this.dragged === _this.begin && order + 1 <= _this.end.order) {
                    _this.updateSelection(_this.dragged, order - 1, target);
                }
                else if (_this.dragged === _this.end && order - 1 >= _this.begin.order) {
                    _this.updateSelection(_this.dragged, order + 1, target);
                }
            }
        });
        this.el.addEventListener('dragend', function (e) {
            var target = e.target;
            target.classList.remove(_this.config.draggedClass);
            _this.dragged = null;
        });
    };
    Markee.prototype.initClickEvents = function () {
        var _this = this;
        this.el.addEventListener('dblclick', function (evt) {
            var target = evt.target;
            if (_this.isToken(target)) {
                var order = Number.parseInt(target.dataset.order);
                _this.begin.order = order - 1;
                _this.begin.node.style.order = '' + _this.begin.order;
                _this.end.order = order + 1;
                _this.end.node.style.order = '' + _this.end.order;
                _this.updateSelectedChildren();
            }
        });
    };
    Markee.prototype.isToken = function (target) {
        return target.classList.contains(this.config.tokenClass);
    };
    Markee.prototype.updateSelection = function (dragged, order, target) {
        dragged.node.style.order = '' + order;
        dragged.order = order;
        this.updateSelectedChildren();
    };
    Markee.prototype.updateSelectedChildren = function () {
        var _this = this;
        var selectedText = '';
        var startIdx = this.begin.order / 2;
        var endIdx = this.end.order / 2;
        Array.from(this.el.children).forEach(function (child, idx) {
            if (idx >= startIdx && idx < endIdx) {
                child.classList.add(_this.config.selectedClass);
                selectedText += ' ' + child.textContent;
            }
            else {
                child.classList.remove(_this.config.selectedClass);
            }
        });
        this.config.onMarked(selectedText, startIdx, endIdx - 1);
    };
    Markee.prototype.createMarker = function (isBegin, order) {
        if (isBegin === void 0) { isBegin = false; }
        var container = document.createElement('div');
        var id = (isBegin ? this.config.beginClass : this.config.endClass);
        container.innerHTML = "<div draggable=true class=\"" + this.config.markerClass + " " + id + "\"" +
            (" id=" + id + " style=\"order:" + order + "\"></div>");
        var node = container.firstElementChild;
        return {
            node: node,
            order: order,
            isBegin: isBegin
        };
    };
    return Markee;
}());
exports.Markee = Markee;
//# sourceMappingURL=index.js.map

/***/ })
/******/ ]);